Get Deployment
- GET /deployments/{deployment_id}
Retrieves information about a Deployment.
Path Parameters
-
deployment_idstringrequired -
Identifier for the Deployment
Query Parameters
-
show_securityboolean · default: false Whether to include the Elasticsearch 2.x security information in the response - can be large per cluster and also include credentials
-
show_metadataboolean · default: false Whether to include the full cluster metadata in the response - can be large per cluster and also include credentials
-
show_plansboolean · default: true Whether to include the full current and pending plan information in the response - can be large per cluster
-
show_plan_logsboolean · default: false Whether to include with the current and pending plan information the attempt log - can be very large per cluster
-
show_plan_historyboolean · default: false Whether to include the plan history with the current and pending plan information. The results can be very large per cluster. By default, if a given resource kind (e.g. Elasticsearch, Kibana, etc.) has more than 100 plans (which should be very rare, most likely caused by a bug) only 100 plans are returned for the given resource type: The first 10 plans, and the last 90 plans for that resource type. If ALL of the plans are desired, pass the
force_all_plan_historyparameter with a value oftrue.-
show_plan_defaultsboolean · default: false If showing plans, whether to show values that are left at their default value (less readable but more informative)
-
convert_legacy_plansboolean · default: false If showing plans, whether to leave pre-2.0.0 plans in their legacy format (the default), or whether to update them to 2.0.x+ format (if 'true')
-
show_system_alertsinteger · default: 0 Number of system alerts (such as forced restarts due to memory limits) to be included in the response - can be large per cluster. Negative numbers or 0 will not return field.
-
show_settingsboolean · default: false Whether to show cluster settings in the response.
-
show_instance_metricsboolean · default: true Whether to show resources instance metrics in the response.
-
show_instance_configurationsboolean · default: true If true, will return details for each instance configuration referenced by the deployment.
-
enrich_with_templateboolean · default: true If showing plans, whether to enrich the plan by including the missing elements from the deployment template it is based on
-
force_all_plan_historyboolean · default: false Force show the entire plan history no matter how long. As noted in the
show_plan_historyparameter description, by default, a maximum of 100 plans are shown per resource. Iftrue, this parameter overrides the default, and ALL plans are returned. Use with care as the plan history can be VERY large. Consider pairing withshow_plan_logs=false.-
clear_transientboolean · default: false If set (defaults to false) then removes the transient section from all child resources, making it safe to reapply via an update
Responses
The Deployment info response
-
idstringrequired -
A randomly-generated id of this Deployment
-
namestringrequired -
The name of this deployment
-
aliasstring -
A user-defined deployment alias for user-friendly resource URLs
-
healthybooleanrequired -
Whether the deployment is overall healthy or not (one or more of the resource info subsections will have healthy: false)
-
resourcesDeploymentResourcesrequired -
Describes a resource belonging to a Deployment
-
elasticsearchElasticsearchResourceInforequired -
List of Elasticsearch resources in your Deployment
-
ref_idstringrequired -
The locally-unique user-specified id of a Resource
-
idstringrequired -
The randomly-generated id of a Resource
-
regionstringrequired -
The region where this resource exists
-
infoElasticsearchClusterInforequired -
The information for an Elasticsearch cluster.
-
cluster_idstringrequired -
The id of the cluster
-
cluster_namestringrequired -
The name of the cluster
-
deployment_idstring -
The id of the deployment that this Elasticsearch belongs to.
-
healthybooleanrequired -
Whether the cluster is healthy or not (one or more of the info subsections will have healthy: false)
-
statusrequired -
Cluster status
-
Values:
initializingstoppingstoppedrebootingrestartingreconfiguringstarted -
plan_infoElasticsearchClusterPlansInforequired -
Information about the current, pending, and past Elasticsearch cluster plans.
-
healthybooleanrequired -
Whether the plan situation is healthy (if unhealthy, means the last plan attempt failed)
-
currentElasticsearchClusterPlanInfo -
Information about the Elasticsearch cluster plan.
-
plan_attempt_idstring -
A UUID for each plan attempt
-
plan_attempt_namestring -
A human readable name for each plan attempt, only populated when retrieving plan histories
-
healthybooleanrequired -
Either the plan ended successfully, or is not yet completed (and no errors have occurred)
-
attempt_start_timestring -
When this plan attempt (ie to apply the plan to the cluster) started (ISO format in UTC)
-
attempt_end_timestring -
If this plan completed or failed (ie is not pending), when the attempt ended (ISO format in UTC)
-
plan_end_timestring -
If this plan is not current or pending, when the plan was no longer active (ISO format in UTC)
-
planElasticsearchClusterPlan -
The plan for the Elasticsearch cluster.
-
cluster_topologyElasticsearchClusterTopologyElementrequired -
idstring -
Unique identifier of this topology element
-
node_typeElasticsearchNodeType -
Controls the combinations of Elasticsearch node types. TIP: By default, the Elasticsearch node is master eligible, can hold data, and run ingest pipelines. WARNING: Do not set for tiebreaker topologies.
-
masterboolean -
Defines whether this node can be elected master (default: false)
-
databoolean -
Defines whether this node can hold data (default: false)
-
ingestboolean -
Defines whether this node can run an ingest pipeline (default: false)
-
mlboolean -
Defines whether this node can run ml jobs, valid only for versions 5.4.0 or greater (default: false)
-
node_roles -
The list of node roles for this topology element (ES version >= 7.10). Allowable values are: master, ingest, ml, data_hot, data_content, data_warm, data_cold, data_frozen, remote_cluster_client, transform
-
Values:
masteringestmldata_hotdata_contentdata_warmdata_colddata_frozenremote_cluster_clienttransform -
memory_per_nodeinteger -
The memory capacity in MB for each node of this type built in each zone.
-
node_count_per_zoneinteger -
The number of nodes of this type that are allocated within each zone. (i.e. total capacity per zone =
node_count_per_zone*memory_per_nodein MB). Cannot be set for tiebreaker topologies. For dedicated master nodes, must be 1 if an entry exists. -
zone_countinteger -
The default number of zones in which data nodes will be placed
-
elasticsearchElasticsearchConfiguration -
The Elasticsearch cluster settings. When specified at the top level, provides a field-by-field default. When specified at the topology level, provides the override settings.
-
versionstring -
The version of the Elasticsearch cluster (must be one of the ECE supported versions). Currently cannot be different across the topology (and is generally specified in the globals). Defaults to the latest version if not specified.
-
docker_imagestring -
A docker URI that allows overriding of the default docker image specified for this version
-
system_settingsElasticsearchSystemSettings -
A subset of Elasticsearch settings. TIP: To define the complete set of Elasticsearch settings, use
ElasticsearchSystemSettingswithuser_settings_override*anduser_settings*. -
scriptingElasticsearchScriptingUserSettings -
Controls the languages supported by the Elasticsearch cluster, such as Painless, Mustache, and Expressions. Controls how the languages are used, such as file, index, and inline. TIP: For complex configurations, leave these blank and configure these settings in the user YAML or JSON.
-
painless_enabledboolean -
(5.x+ only) If enabled (the default) then the painless scripting engine is allowed as a sandboxed language. Sandboxed languages are the only ones allowed if 'sandbox_mode' is set to true. NOTES: (Corresponds to the parameters 'script.engine.painless.[file|stored|inline]')
-
mustache_enabledboolean -
(5.x+ only) If enabled (the default) then the mustache scripting engine is allowed as a sandboxed language. Sandboxed languages are the only ones allowed if 'sandbox_mode' is set to true. NOTES: (Corresponds to the parameters 'script.engine.mustache.[file|stored|inline]')
-
expressions_enabledboolean -
(5.x+ only) If enabled (the default) then the expressions scripting engine is allowed as a sandboxed language. Sandboxed languages are the only ones allowed if 'sandbox_mode' is set to true. NOTES: (Corresponds to the parameters 'script.engine.expression.[file|stored|inline]')
-
storedElasticsearchScriptTypeSettings -
Enables scripting for the specified type and controls other parameters. Store scripts in indexes (
stored), upload in file bundles (file), or use in API requests (inline). -
enabledboolean -
If enabled (default: true) then scripts are enabled, either for sandboxing languages (by default), or for all installed languages if 'sandbox_mode' is disabled (or for 6.x). NOTES: (Corresponds to the parameter 'script.file|stored/indexed|inline')
-
sandbox_modeboolean -
If enabled (default: true) and this script type is enabled, then only the sandbox languages are allowed. By default the sandbox languages are painless, expressions and mustache, but this can be restricted via the 'painless_enabled', 'mustache_enabled' 'expression_enabled' settings.NOTES: Not supported in 6.x. (Corresponds to the parameters 'script.engine.[painless|mustache|expressions].[file|stored|inline]')
-
fileElasticsearchScriptTypeSettings -
Enables scripting for the specified type and controls other parameters. Store scripts in indexes (
stored), upload in file bundles (file), or use in API requests (inline). -
enabledboolean -
If enabled (default: true) then scripts are enabled, either for sandboxing languages (by default), or for all installed languages if 'sandbox_mode' is disabled (or for 6.x). NOTES: (Corresponds to the parameter 'script.file|stored/indexed|inline')
-
sandbox_modeboolean -
If enabled (default: true) and this script type is enabled, then only the sandbox languages are allowed. By default the sandbox languages are painless, expressions and mustache, but this can be restricted via the 'painless_enabled', 'mustache_enabled' 'expression_enabled' settings.NOTES: Not supported in 6.x. (Corresponds to the parameters 'script.engine.[painless|mustache|expressions].[file|stored|inline]')
-
inlineElasticsearchScriptTypeSettings -
Enables scripting for the specified type and controls other parameters. Store scripts in indexes (
stored), upload in file bundles (file), or use in API requests (inline). -
enabledboolean -
If enabled (default: true) then scripts are enabled, either for sandboxing languages (by default), or for all installed languages if 'sandbox_mode' is disabled (or for 6.x). NOTES: (Corresponds to the parameter 'script.file|stored/indexed|inline')
-
sandbox_modeboolean -
If enabled (default: true) and this script type is enabled, then only the sandbox languages are allowed. By default the sandbox languages are painless, expressions and mustache, but this can be restricted via the 'painless_enabled', 'mustache_enabled' 'expression_enabled' settings.NOTES: Not supported in 6.x. (Corresponds to the parameters 'script.engine.[painless|mustache|expressions].[file|stored|inline]')
-
reindex_whiteliststring -
Limits remote Elasticsearch clusters that can be used as the source for '_reindex' API commands
-
auto_create_indexboolean -
If true (the default), then any write operation on an index that does not currently exist will create it. NOTES: (Corresponds to the parameter 'action.auto_create_index')
-
enable_close_indexboolean -
Defaults to false on versions <= 7.2.0, true otherwise. If false, then the API commands to close indices are disabled. This is important because Elasticsearch does not snapshot or migrate close indices on versions under 7.2.0, therefore standard Elastic Cloud configuration operations will cause irretrievable loss of indices' data. NOTES: (Corresponds to the parameter 'cluster.indices.close.enable')
-
destructive_requires_nameboolean -
If true (default is false) then the index deletion API will not support wildcards or '_all'. NOTES: (Corresponds to the parameter 'action.destructive_requires_name')
-
watcher_trigger_enginestring -
The trigger engine for Watcher, defaults to 'scheduler' - see the xpack documentation for more information. NOTES: (Corresponds to the parameter '(xpack.)watcher.trigger.schedule.engine', depending on version. Ignored from 6.x onwards.)
-
default_shards_per_indexinteger -
(2.x only - to get the same result in 5.x template mappings must be used) Sets the default number of shards per index, defaulting to 1 if not specified. (Corresponds to the parameter 'index.number_of_shards' in 2.x, not supported in 5.x)
-
monitoring_collection_intervalinteger -
The default interval at which monitoring information from the cluster if collected, if monitoring is enabled. NOTES: (Corresponds to the parameter 'marvel.agent.interval' in 2.x and 'xpack.monitoring.collection.interval' in 5.x)
-
monitoring_history_durationstring -
The duration for which monitoring history is stored (format '(NUMBER)d' eg '3d' for 3 days). NOTES: ('Corresponds to the parameter xpack.monitoring.history.duration' in 5.x, defaults to '7d')
-
user_settings_jsonobject -
An arbitrary JSON object allowing cluster owners to set their parameters (only one of this and 'user_settings_yaml' is allowed), provided the parameters arey are on the allowlist and not on the denylist. NOTES: (This field together with 'user_settings_override*' and 'system_settings' defines the total set of Elasticsearch settings)
-
user_settings_yamlstring -
An arbitrary YAML object allowing cluster owners to set their parameters (only one of this and 'user_settings_json' is allowed), provided the parameters arey are on the allowlist and not on the denylist. NOTES: (This field together with 'user_settings_override*' and 'system_settings' defines the total set of Elasticsearch settings)
-
user_settings_override_jsonobject -
An arbitrary JSON object allowing ECE admins owners to set clusters' parameters (only one of this and 'user_settings_override_yaml' is allowed), ie in addition to the documented 'system_settings'. NOTES: (This field together with 'system_settings' and 'user_settings*' defines the total set of Elasticsearch settings)
-
user_settings_override_yamlstring -
An arbitrary YAML object allowing ECE admins owners to set clusters' parameters (only one of this and 'user_settings_override_json' is allowed), ie in addition to the documented 'system_settings'. NOTES: (This field together with 'system_settings' and 'user_settings*' defines the total set of Elasticsearch settings)
-
enabled_built_in_pluginsstring -
A list of plugin names from the Elastic-supported subset that are bundled with the version images. NOTES: (Users should consult the Elastic stack objects to see what plugins are available, this is currently only available from the UI)
-
user_pluginsElasticsearchUserPlugin -
A list of admin-uploaded plugin objects that are available for this user.
-
namestringrequired -
The name of the plugin
-
urlstringrequired -
The URL of the plugin (must be accessible from the ECE infrastructure)
-
elasticsearch_versionstringrequired -
The supported Elasticsearch version (must match the version in the plan)
-
user_bundlesElasticsearchUserBundle -
A list of admin-uploaded bundle objects (eg scripts, synonym files) that are available for this user.
-
namestringrequired -
The name of the bundle
-
urlstringrequired -
The URL of the bundle, which must be accessible from the ECE infrastructure. This URL could be cached by platform, make sure to change it when updating the bundle
-
elasticsearch_versionstringrequired -
The supported Elasticsearch version (must match the version in the plan)
-
curationElasticsearchCuration -
The structure that defines the routing settings for index curation.
-
from_instance_configuration_idstringrequired -
The source instance configuration
-
to_instance_configuration_idstringrequired -
The destination instance configuration
-
node_attributesmap string to string -
Defines the Elasticsearch node attributes for the instances in the topology
-
instance_configuration_idstring -
Controls the allocation of this topology element as well as allowed sizes and node_types. It needs to match the id of an existing instance configuration.
-
instance_configuration_versioninteger -
The version of the Instance Configuration Id. If it is unset, the meaning depends on read vs writes. For deployment reads, it is equivalent to version 0 (or the IC is unversioned); for deployment creates and deployment template use, it is equivalent to 'the latest version'; and for deployment updates, it is equivalent to 'retain the current version'.
-
sizeTopologySize -
Measured by the amount of a resource. The final cluster size is calculated using multipliers from the topology instance configuration.
-
autoscaling_minTopologySize -
Measured by the amount of a resource. The final cluster size is calculated using multipliers from the topology instance configuration.
-
autoscaling_maxTopologySize -
Measured by the amount of a resource. The final cluster size is calculated using multipliers from the topology instance configuration.
-
autoscaling_policy_override_jsonobject -
An arbitrary JSON object overriding the default autoscaling policy. Don't set unless you really know what you are doing.
-
topology_element_controlTopologyElementControl -
Controls for the topology element. Only used as part of the deployment template. Ignored if included as part of a deployment.
-
minTopologySizerequired -
Measured by the amount of a resource. The final cluster size is calculated using multipliers from the topology instance configuration.
-
autoscaling_tier_overrideboolean -
Set to true to enable autoscaling for this topology element, even if the cluster-level 'autoscaling_enabled' field is false. Note that 'autoscaling_tier_override' cannot be set to false if cluster-level 'autoscaling_enabled' is true. Currently only supported for the 'ml' tier
-
elasticsearchElasticsearchConfigurationrequired -
The Elasticsearch cluster settings. When specified at the top level, provides a field-by-field default. When specified at the topology level, provides the override settings.
-
deployment_templateDeploymentTemplateReference -
Specifies the deployment template used to create the plan.
-
transientTransientElasticsearchPlanConfiguration -
Defines the configuration parameters that control how the plan is applied. For example, the Elasticsearch cluster topology and Elasticsearch settings.
-
strategyPlanStrategy -
The options for performing a plan change. Specify only one property each time. The default is
grow_and_shrink. -
rollingRollingStrategyConfig -
Performs inline, rolling configuration changes that mutate existing containers. TIP: This is the fastest way to update a plan, but can fail for complex plan changes, such as topology changes. Also, this is less safe for configuration changes that leave a cluster in a non running state. NOTE: When you perform a major version upgrade, and 'group_by' is set to 'pass:macros[all]';, rolling is required.
-
group_bystring -
Specifies the grouping attribute to use when rolling several instances. Instances that share the same value for the provided attribute key are rolled together as a unit. Examples that make sense to use are '__all__' (roll all instances as a single unit), 'logical_zone_name' (roll instances by zone), '__name__' (roll one instance at a time, the default if not specified). Note that '__all__' is required when performing a major version upgrade
-
allow_inline_resizeboolean -
Whether we allow changing the capacity of instances (default false). This is currently implemented by stopping, re-creating then starting the affected instance on its associated allocator when performing the changes. NOTES: This requires a round-trip through the allocation infrastructure of the active constructor, as it has to reserve the target capacity without over-committing
-
skip_synced_flushboolean -
Whether to skip attempting to do a synced flush on the filesystem of the container (default: false), which is less safe but may be required if the container is unhealthy
-
shard_init_wait_timeinteger -
The time, in seconds, to wait for shards that show no progress of initializing before rolling the next group (default: 10 minutes)
-
grow_and_shrinkGrowShrinkStrategyConfig -
A strategy that creates instances with the new plan, migrates data from the old instances, then shuts down the old instances.
GrowShrinkStrategyConfigis safer than 'rolling' and ensures single node availability during a plan change, but can be a lot slower on larger clusters. -
rolling_grow_and_shrinkRollingGrowShrinkStrategyConfig -
A strategy that creates new Elasticsearch instances, Kibana instances, and APM Servers with the new plan, then migrates the node data to minimize the amount of spare capacity.
-
autodetectAutodetectStrategyConfig -
A strategy that lets constructor choose the most optimal way to execute the plan.
-
plan_configurationElasticsearchPlanControlConfiguration -
The configuration settings for the timeout and fallback parameters.
-
timeoutinteger -
The total timeout in seconds after which the plan is cancelled even if it is not complete. Defaults to 4x the max memory capacity per node (in MB). NOTES: A 3 zone cluster with 2 nodes of 2048 each would have a timeout of 4*2048=8192 seconds. Timeout does not include time required to run rollback actions.
-
calm_wait_timeinteger -
This timeout determines how long to give a cluster after it responds to API calls before performing actual operations on it. It defaults to 5s
-
move_instancesInstanceMoveRequest -
fromstringrequired -
The instance id that is going to be moved
-
tostring -
An optional list of allocator ids to which the instance should be moved. If not specified then any available allocator can be used (including the current one if it is healthy)
-
instance_downboolean -
Tells the infrastructure that the instance should be considered as permanently down when deciding how to migrate data to new nodes. If left blank then the system will automatically decide (currently: will treat the instances as up)
-
move_allocatorsAllocatorMoveRequest -
fromstringrequired -
The allocator id off which all instances in the cluster should be moved
-
tostring -
An optional list of allocator ids to which the instance(s) should be moved. If not specified then any available allocator can be used (including the current one if it is healthy)
-
allocator_downboolean -
Tells the infrastructure that all instances on the allocator should be considered as permanently down when deciding how to migrate data to new nodes. If left blank then the system will auto-decide (currently: will treat the allocator as up)
-
move_onlyboolean -
If true (default: false) only move_instances and move_allocators instructions will be executed, all other changes will be ignored
-
reallocate_instancesboolean -
If true (default: false) does not allow re-using any existing instances currently in the cluster, ie even unchanged instances will be re-created
-
preferred_allocatorsstring -
List of allocators on which instances are placed if possible (if not possible/not specified then any available allocator with space is used)
-
Map containing allocators tags in form of key value pairs, increasing the likelihood during move requests for allocators with matching tags, to be selected as target allocators
-
skip_snapshotboolean -
If true (default: false), does not take (or require) a successful snapshot to be taken before performing any potentially destructive changes to this cluster
-
max_snapshot_attemptsinteger -
If taking a snapshot (ie unless 'skip_snapshots': true) then will retry on failure at most this number of times (default: 5)
-
max_snapshot_ageinteger -
When you take a snapshot and 'skip_snapshots' is false, specifies the maximum age in seconds of the most recent snapshot before a new snapshot is created. Default is 300
-
extended_maintenanceboolean -
If true (default false), does not clear the maintenance flag (which prevents its API from being accessed except by the constructor) on new instances added until after a snapshot has been restored, otherwise, the maintenance flag is cleared once the new instances successfully join the new cluster
-
cluster_reboot -
Set to 'forced' to force a reboot as part of the upgrade plan. NOTES: (ie taking an existing plan and leaving it alone except for setting 'transient.plan_configuration.cluster_reboot': 'forced' will reboot the cluster)
-
Values:
forced -
override_failsafeboolean -
If false (the default) then the plan will fail out if it believes the requested sequence of operations can result in data loss - this flag will override some of these restraints
-
skip_data_migrationboolean -
If true (default: false) then the plan will not wait for data to be migrated from old instances to new instances before continuing the plan (potentially deleting the old instances and losing data)
-
skip_upgrade_checkerboolean -
If false, the cluster is checked for issues that should be resolved before migration (eg contains old Lucene segments), if true this is bypassed
-
skip_post_upgrade_stepsboolean -
If false (the default), the cluster will run (currently) 2.x->5.x operations for any plan change ending with a 5.x cluster (eg apply a cluster license, ensure Monitoring is configured)
-
skip_snapshot_post_major_upgradeboolean -
If false (the default), the cluster will perform a snapshot after a major version upgrade takes place
-
restore_snapshotRestoreSnapshotConfiguration -
Restores a snapshot from a local or remote repository.
-
repository_namestring -
If specified, contains the name of the snapshot repository - else will default to the Elastic Cloud system repo ('found-snapshots')
-
snapshot_namestringrequired -
The name of the snapshot to restore. Use '__latest_success__' to get the most recent snapshot from the specified repository
-
repository_configRestoreSnapshotRepoConfiguration -
Configures the location of a remote repository. The default is the system repository.
-
raw_settingsobject -
The remote snapshot settings raw JSON - see the Elasticsearch '_snapshot' documentation for more details on supported formats
-
restore_payloadRestoreSnapshotApiConfiguration -
The configuration for the restore command, such as which indices you want to restore.
-
indicesstring -
The list of indices to restore (supports +ve and -ve selection and wildcarding - see the default Elasticsearch index format documentation)
-
raw_settingsobject -
This JSON object (merged with the 'indices' field (if present) is passed untouched into the restore command - see the Elasticsearch '_snapshot' documentation for more details on supported formats
-
strategy -
The restore strategy to use. Defaults to a full restore. Partial restore will attempt to restore unavailable indices only
-
Values:
partialfullrecovery -
source_cluster_idstring -
If specified, contains the name of the source cluster id. Do not send this if you are sending repository_config
-
snapshot_dependencySnapshotDependencyConfiguration -
Configuration for attaching a snapshot repository dependency from another cluster. This creates a snapshot repository in the target cluster pointing to the source cluster's snapshots.
-
source_cluster_idstringrequired -
The cluster ID of the source cluster whose snapshots will be made available
-
remote_clustersRemoteResources -
The list of resources used as remote clusters
-
resourcesRemoteResourceRefrequired -
The remote resources
-
deployment_idstringrequired -
The id of the deployment
-
elasticsearch_ref_idstringrequired -
The locally-unique user-specified id of an Elasticsearch Resource
-
aliasstringrequired -
The alias for this remote cluster. Aliases must only contain letters, digits, dashes and underscores
-
If true, skip this cluster during search if it is disconnected. Default: false
-
infoRemoteResourceInfo -
Information about a Remote Cluster.
-
healthybooleanrequired -
Whether or not the remote cluster is healthy
-
connectedbooleanrequired -
Whether or not there is at least one connection to the remote cluster.
-
compatiblebooleanrequired -
Whether or not the remote cluster version is compatible with this cluster version.
-
trustedbooleanrequired -
Whether or not the remote cluster is trusted by this cluster.
-
trusted_backbooleanrequired -
Whether or not the remote cluster trusts this cluster back.
-
cluster_settings_jsonobject -
If specified, contains transient settings to be applied to an Elasticsearch cluster during changes,default values shown below applied. These can be overridden by specifying them in the map (or null to unset). Additional settings can also be set. Settings will be cleared after the plan has finished. If not specified, no settings will be applied. NOTE: These settings are only explicitly cleared for 5.x+ clusters, they must be hand-reset to their defaults in 2.x- (or a cluster reboot will clear them).
- indices.store.throttle.max_bytes_per_sec: 120Mb
- indices.recovery.max_bytes_per_sec: 120Mb
- cluster.routing.allocation.cluster_concurrent_rebalance: 5
- cluster.routing.allocation.node_initial_primaries_recoveries: 5
- cluster.routing.allocation.node_concurrent_incoming_recoveries: 5 For version 8.1 and later no defaults are provided through this mechanism, but instead hardware dependent settings are provided to each instance.
-
autoscaling_enabledboolean -
Enable autoscaling for this Elasticsearch cluster.
-
plan_attempt_logClusterPlanStepInforequired -
step_idstringrequired -
ID of current step
-
startedstringrequired -
When the step started (ISO format in UTC)
-
completedstring -
When the step completed (ISO format in UTC)
-
duration_in_millisinteger -
The duration of the step in MS
-
statusrequired -
The status of the step (success, warning, error - warning means something didn't go as expected but it was not serious enough to abort the plan)
-
Values:
successwarningerrorpending -
info_logClusterPlanStepLogMessageInforequired -
Human readable summaries of the step, including messages for each stage of the step
-
timestampstringrequired -
Timestamp marking on info log of step
-
delta_in_millisinteger -
Time in milliseconds since previous log message
-
messagestringrequired -
Human readable log message
-
detailsmap string to stringrequired -
A map with details for the log about what happened during the step execution. Keys and values for are always both strings, representing the name of the detail and its value, respectively.
-
internal_detailsmap string to string -
A json object with sensitive details for the log, visible only to admins. May contain nested json objects.
-
failure_typestring -
The failure type, in case the step failed
-
sourceChangeSourceInfo -
A container for information about the source of a change.
-
facilitatorstringrequired -
The service where the change originated from
-
actionstringrequired -
The type of plan change that was initiated
-
datestringrequired -
The time the change was initiated
-
user_idstring -
The user that requested the change
-
admin_idstring -
The admin user that requested the change
-
remote_addressesstring -
The host addresses of the user that originated the change
-
warningsClusterPlanWarningrequired -
errorClusterPlanAttemptError -
Information about an error during a plan attempt.
-
timestampstringrequired -
Timestamp marking on info log of step
-
messagestringrequired -
Human readable error message
-
detailsmap string to stringrequired -
A map with details regarding the error. Both the keys and values are always strings, representing the name of the detail and its value, respectively.
-
failure_typestring -
The failure type
-
pendingElasticsearchClusterPlanInfo -
Information about the Elasticsearch cluster plan.
-
historyElasticsearchClusterPlanInforequired -
elasticsearchElasticsearchInforequired -
Information about the Elasticsearch cluster.
-
healthybooleanrequired -
Whether the Elasticsearch cluster is healthy (check the sub-objects for more details if not)
-
shard_infoElasticsearchShardsInforequired -
WARNING This endpoint is deprecated and scheduled to be removed in the next major version. Use
shards_statusinstead.Information about the shards and replicas that comprise the Elasticsearch indices.
-
healthybooleanrequired -
Whether the shard situation is healthy (any unavailable shards is unhealthy)
-
available_shardsElasticsearchShardElementrequired -
instance_namestringrequired -
The Elastic Cloud name/id of the instance (container)
-
shard_countintegerrequired -
The number of shards of the given type (available/unavailable) on this instance
-
shards_statusElasticsearchShardsStatus -
Shards status represented as green, yellow, or red, as returned by the Elasticsearch cluster health API
-
statusrequired -
Indicates the elasticsearch cluster health status as a color
-
Values:
greenredyellow -
master_infoElasticsearchMasterInforequired -
Information about the master nodes in the Elasticsearch cluster.
-
healthybooleanrequired -
Whether the master situation in the cluster is healthy (ie is the number of masters != 1), or do any instances have no master
-
mastersElasticsearchMasterElementrequired -
master_node_idstringrequired -
The Elasticsearch node id of a master node
-
master_instance_namestring -
The corresponding instance name of the container hosting the Elasticsearch master node, if available
-
instancesstringrequired -
The names of the instance/container hosting the node belong to the cluster with the given master
-
instances_with_no_masterstringrequired -
A list of any instances with no master
-
blocking_issuesElasticsearchClusterBlockingIssuesrequired -
WARNING This endpoint is deprecated and scheduled to be removed in the next major version. Use
cluster_blocking_issuesinsteadIssues that prevent the Elasticsearch cluster or index from operating correctly.
-
healthybooleanrequired -
Whether the cluster has issues (false) or not (true)
-
cluster_levelElasticsearchClusterBlockingIssueElementrequired -
A list of issues that affect availability of entire cluster
-
descriptionstringrequired -
Description of the issue
-
instancesstringrequired -
A list of instances that are affected by the issue
-
index_levelElasticsearchClusterBlockingIssueElementrequired -
A list of issues that affect availability of the cluster's indices
-
descriptionstringrequired -
Description of the issue
-
instancesstringrequired -
A list of instances that are affected by the issue
-
cluster_blocking_issuesElasticsearchBlockingIssues -
Issues that prevent the Elasticsearch cluster or index from correctly operating.
-
healthybooleanrequired -
Whether the cluster has issues (false) or not (true)
-
blocksElasticsearchBlockingIssueElementrequired -
A list of blocks that affect the availability of the cluster
-
descriptionstringrequired -
Description of the block
-
levelrequired -
Applicable level for the block. Either global ie. cluster-wide or index level
-
Values:
indexglobal -
metadataClusterMetadataInforequired -
Information about the public and internal state, and the configuration settings of an Elasticsearch cluster.
-
versionintegerrequired -
The resource version number of the cluster metadata
-
last_modifiedstringrequired -
The most recent time the cluster metadata was changed (ISO format in UTC)
-
endpointstring -
The DNS name of the cluster endpoint, if available
-
service_urlstring -
The full URL to access this deployment resource
-
aliased_endpointstring -
The DNS name of the cluster endpoint derived from the deployment alias, if available
-
aliased_urlstring -
The full aliased URL to access this deployment resource
-
cloud_idstring -
The cloud ID, an encoded string that provides other Elastic services with the necessary information to connect to this Elasticsearch and Kibana (only present if both exist)
-
rawobject -
An unstructured JSON representation of the public and internal state (can be filtered out via URL parameter). The contents and structure of the
rawfield can change at any time. -
portsClusterMetadataPortInfo -
Information about the ports that allow communication between the Elasticsearch cluster and various protocols.
-
httpintegerrequired -
Port where the cluster listens for HTTP traffic
-
httpsintegerrequired -
Port where the cluster listens for HTTPS traffic
-
transport_passthroughintegerrequired -
Port where the cluster listens for transport traffic using TLS
-
services_urlsServiceUrl -
A list of the URLs to access services that the resource provides at this time. Note that if the service is not running or has not started yet, the URL to access it won't be available
-
topologyClusterTopologyInforequired -
The topology for Elasticsearch clusters, multiple Kibana instances, or multiple APM Servers. The
ClusterTopologyInfoalso includes the instances and containers, and where they are located. -
healthybooleanrequired -
Whether the cluster topology is healthy (ie all instances are started and the services they run - ie elasticsearch - are available
-
instancesClusterInstanceInforequired -
instance_namestringrequired -
The name of the instance in Elastic Cloud
-
instance_configurationClusterInstanceConfigurationInfo -
Information about a configuration that creates a Kibana instance or APM Server.
-
idstringrequired -
The id of the configuration used to create the instance
-
namestringrequired -
The name of the configuration used to create the instance
-
config_versioninteger -
If the IC is configuration controlled, this field is the version either being read back (reads return the latest IC unless specified by the 'config_version' URL param), or the version to update. Cannot be used in creates. For unversioned IC reads it is left empty.
-
service_versionstring -
The version of the service that the instance is running (eg Elasticsearch or Kibana), if available
-
healthybooleanrequired -
Whether the instance is healthy (ie started and running)
-
container_startedbooleanrequired -
Whether the container has started (does not tell you anything about the service -ie Elasticsearch- running inside the container)
-
service_runningbooleanrequired -
Whether the service launched inside the container -ie Elasticsearch- is actually running
-
maintenance_modebooleanrequired -
Whether the service is is maintenance mode (meaning that the proxy is not routing external traffic to it)
-
zonestring -
The zone in which this instance is being allocated
-
allocator_idstring -
The id of the allocator on which this instance is running (if the container is started or starting)
-
memoryClusterInstanceMemoryInfo -
Information about the specific instances memory capacity and its usage
-
instance_capacityintegerrequired -
The memory capacity in MB of the instance
-
instance_capacity_plannedinteger -
The planned memory capacity in MB of the instance (only shown when an override is present)
-
memory_pressureinteger -
The % memory pressure of Elasticsearch JVM heap space if available (60-75% consider increasing capacity, >75% can incur significant performance and stability issues)
-
native_memory_pressureinteger -
The % memory pressure of the instance Docker container (if available)
-
diskClusterInstanceDiskInfo -
Information about the use and storage capacity of a Kibana instance or APM Server.
-
disk_space_availableinteger -
If known, the amount of total disk space available to the container in MB
-
disk_space_usedintegerrequired -
The amount of disk space being used by the service in MB
-
storage_multipliernumberrequired -
The storage multiplier originally defined to calculate disk space.
-
service_rolesstring -
List of roles assigned to the service running in the instance. Currently only populated for Elasticsearch, with possible values: master,data,ingest,ml
-
node_roles -
A list of the node roles assigned to the service running in the instance. Currently populated only for Elasticsearch.
-
Values:
masteringestmldata_hotdata_contentdata_warmdata_colddata_frozenremote_cluster_clienttransformvoting_only -
instance_overridesInstanceOverrides -
capacityinteger -
Sets the memory capacity for the instances container. Requires a restart to take effect.
-
storage_multipliernumber -
Overrides the disk quota multiplier for the instance
-
system_alertsClusterSystemAlert -
List of cluster system alerts
-
timestampstringrequired -
Timestamp marking the system alert
-
instance_namestringrequired -
Instance that caused the system alert
-
urlstring -
The URL related to the event. Only applicable for alert_type: heap_dump
-
exit_codeinteger -
The exit_code related to the event. Only applicable for alert_type: slain
-
associated_kibana_clustersKibanaSubClusterInforequired -
kibana_idstringrequired -
The Kibana cluster Id
-
enabledbooleanrequired -
Whether the associated Kibana cluster is currently available
-
linksmap string to Hyperlink -
A map of application-specific operations (which map to 'operationId's in the Swagger API) to metadata about that operation
-
<string>Hyperlink -
need_elevated_permissionsboolean -
Whether the operation requires elevated permissions (when the field is present, elevated permissions are required).
-
associated_apm_clustersApmSubInforequired -
apm_idstringrequired -
The APM cluster Id
-
enabledbooleanrequired -
Whether the associated APM cluster is currently available
-
linksmap string to Hyperlink -
A map of application-specific operations (which map to 'operationId's in the Swagger API) to metadata about that operation
-
<string>Hyperlink -
need_elevated_permissionsboolean -
Whether the operation requires elevated permissions (when the field is present, elevated permissions are required).
-
associated_appsearch_clustersAppSearchSubInforequired -
app_search_idstringrequired -
The App Search Id
-
enabledbooleanrequired -
Whether the associated App Search is currently available
-
linksmap string to Hyperlink -
A map of application-specific operations (which map to 'operationId's in the Swagger API) to metadata about that operation
-
<string>Hyperlink -
need_elevated_permissionsboolean -
Whether the operation requires elevated permissions (when the field is present, elevated permissions are required).
-
associated_enterprise_search_clustersEnterpriseSearchSubInforequired -
enterprise_search_idstringrequired -
The Enterprise Search Id
-
enabledbooleanrequired -
Whether the associated Enterprise Search is currently available
-
linksmap string to Hyperlink -
A map of application-specific operations (which map to 'operationId's in the Swagger API) to metadata about that operation
-
<string>Hyperlink -
need_elevated_permissionsboolean -
Whether the operation requires elevated permissions (when the field is present, elevated permissions are required).
-
securityElasticsearchClusterSecurityInfo -
For 2.x Elasticsearch clusters, specifies the information about the users and roles. For 5.x Elasticsearch clusters, use the Kibana management UI.
-
versionintegerrequired -
The resource version number of the security settings
-
last_modifiedstringrequired -
The most recent time the security settings were changed (ISO format in UTC)
-
usersElasticsearchClusterUserrequired -
usernamestringrequired -
The username
-
password_hashstringrequired -
The hashed password
-
rolesobjectrequired -
An arbitrarily nested JSON object mapping roles to sets of resources and permissions - see the Elasticsearch security documentation for more details on roles
-
users_rolesElasticsearchClusterRolerequired -
elasticsearch_monitoring_infoElasticsearchMonitoringInfo -
Information about the monitoring status for the Elasticsearch cluster.
-
healthybooleanrequired -
Whether the Monitoring configuration has been successfully applied
-
last_modifiedstringrequired -
The time the monitoring configuration was last changed
-
last_update_statusstringrequired -
The status message from the last update (successful or not)
-
source_cluster_idsstringrequired -
The list of clusters Ids from which this cluster is currently receiving monitoring data
-
destination_cluster_idsstringrequired -
The list of clusters Ids to which this cluster is currently sending monitoring data
-
snapshotsSnapshotStatusInforequired -
Information about the snapshot status for the Elasticsearch cluster. For example, the health status.
-
healthybooleanrequired -
Health status of snapshots for this cluster
-
countintegerrequired -
Number of snapshots stored for this cluster
-
latest_successfulboolean -
Latest snapshot status
-
latest_statusstring -
Status of the latest snapshot attempt, if any exist.
-
scheduled_timestring -
Scheduled time of next snapshot attempt
-
latest_end_timestring -
The end time of the most recently attempted snapshot
-
latest_successful_end_timestring -
The end time of the most recently successful snapshot
-
recent_successbooleanrequired -
Indicates whether the cluster has a relatively recent successful snapshot.
-
external_linksExternalHyperlink · uniquerequired -
External resources related to the cluster
-
linksmap string to Hyperlink -
A map of application-specific operations (which map to 'operationId's in the Swagger API) to metadata about that operation
-
<string>Hyperlink -
need_elevated_permissionsboolean -
Whether the operation requires elevated permissions (when the field is present, elevated permissions are required).
-
settingsElasticsearchClusterSettings -
The settings for an Elasticsearch cluster.
-
snapshotClusterSnapshotSettings -
The snapshot configuration settings for an Elasticsearch cluster.
-
repositoryClusterSnapshotRepositoryInfo -
Information about the Elasticsearch cluster snapshot repository.
-
staticClusterSnapshotRepositoryStatic -
The static object for the Elasticsearch cluster snapshot repository.
-
repository_typestring -
Type of snapshot repository, ie: S3
-
settingsobject -
Settings associated with snapshot repository
-
referenceClusterSnapshotRepositoryReference -
The reference object for the Elasticsearch cluster snapshot repository.
-
repository_namestring -
ECE snapshot repository name, from the '/platform/configuration/snapshots/repositories' endpoint
-
defaultClusterSnapshotRepositoryDefault -
The default object for the Elasticsearch cluster snapshot repository.
-
intervalstring -
Interval between snapshots, with the format 'length unit' (space is optional), where unit can be one of: d (day), h (hour), min (minute). Default is 30 minutes
-
pending_intervalstring -
Interval between snapshot progress checks, with the format 'length unit' (space is optional), where unit can be one of: d (day), h (hour), min (minute). Default is 1 minute
-
wait_time_after_snapshottingstring -
The time to wait between snapshot phases (snapshot, purge), with the format 'length unit' (space is optional), where unit can be one of: d (day), h (hour), min (minute). Default is 10 minutes
-
enabledboolean -
Indicates if Snapshotting is enabled
-
suspendedstring -
List of temporary snapshot suspensions
-
retentionClusterSnapshotRetention -
Information about the Elasticsearch cluster snapshot retention.
-
slmboolean -
When set to true, the deployment will have SLM enabled. Default value is true.
-
cron_expressionstring -
Cron expression indicating when should snapshots be taken. This can be enabled only if SLM is enabled for the deployment and 'interval' is not present
-
monitoringManagedMonitoringSettings -
The settings for sending monitoring information to another cluster.
-
target_cluster_idstringrequired -
The Id of the target cluster to which to send monitoring information
-
metadataClusterMetadataSettings -
The top-level configuration settings for the Elasticsearch cluster.
-
namestring -
The display name of the cluster
-
owner_idstring -
The user id (referencing whatever user database is in use) of the cluster owner
-
organization_idstring -
The organization that owns the deployment
-
subscription_levelstring -
Subscription level of the cluster
-
system_ownedboolean -
Indicates if a cluster is system owned (restricts the set of operations that can be performed on it)
-
contact_emailstring -
Contact email for the cluster
-
Whether or not this cluster is hidden from the normal clusters list
-
resourcesClusterMetadataResourcesSettings -
The top-level configuration settings for the Elasticsearch cluster resources.
-
cpuClusterMetadataCpuResourcesSettings -
Specifies the CPU resource settings for the Elasticsearch cluster.
-
boostboolean -
Indicates if the CPU boost flag is enabled or not.
-
hard_limitboolean -
Indicates if the CPU hard limit flag is enabled or not. When set to true (default), allocates CPU timeshare based on the total CPU time multiplied by the relative RAM capacity of the instance on a given host. When set to false, delegates CPU allocation to the operating system to schedule CPU timeshares.
-
curationClusterCurationSettings -
The index curation settings for an Elasticsearch cluster.
-
specsClusterCurationSpecrequired -
Specifications for curation
-
index_patternstringrequired -
Index matching pattern
-
trigger_interval_secondsintegerrequired -
Number of seconds after index creation to trigger this spec
-
dedicated_masters_thresholdinteger -
Threshold starting from which the number of instances in the cluster results in the introduction of dedicated masters. If the cluster is downscaled to a number of nodes below this one, dedicated masters will be removed. Limit is inclusive. When provided the threshold setting is updated. A
nullvalue removes the field. Otherwise, the setting remains as it was set previously. -
traffic_filterTrafficFilterSettings -
The configuration settings for the traffic filter.
-
rulesetsstringrequired -
IDs of the traffic filter rulesets
-
trustElasticsearchClusterTrustSettings -
Configuration of trust with other clusters.
-
accountsAccountTrustRelationship -
The list of trust relationships with different accounts
-
account_idstringrequired -
the ID of the Account
-
namestring -
A human readable name of the trust relationship
-
trust_allbooleanrequired -
If true, all clusters in this account will by default be trusted and the
trust_allowlistis ignored. -
trust_allowliststring -
The list of clusters to trust. Only used when
trust_allis false. -
externalExternalTrustRelationship -
The list of trust relationships with external entities
-
trust_relationship_idstringrequired -
The ID of the external trust relationship
-
namestring -
The name of the external trust relationship. Retrieved from the TrustRelationship and ignored on write.
-
trust_allbooleanrequired -
If true, all clusters in this external entity will be trusted and the
trust_allowlistis ignored. -
trust_allowliststring -
The list of clusters to trust. Only used when
trust_allis false. -
directDirectTrustRelationship -
The list of trust relationships where the certificate is bundled with the trust setting. Allows configuring trust for clusters running outside of an Elastic Cloud managed environment or in an Elastic Cloud environment without an environment level trust established.
-
uidstring -
Auto generated identifier for this trust, allows distinguishing between update vs remove and add.
-
namestringrequired -
a human readable name of the trust relationship
-
type -
The type can either be ESS, ECE, generic or proxy. If none is specified, then generic is assumed. If proxy is specified, trust_all should be false and trust_allowlist, scope_id and additional_node_names should be omitted.
-
Values:
ECEESSgenericproxy -
trust_allbooleanrequired -
If true, scope_id is required and the
trust_allowlistis ignored and all clusters matching the scope id will be trusted. -
trust_allowliststring -
The list of clusters with matching scope to trust. Only used when
trust_allis false. Providing one or more clusters makes scope_id mandatory. -
scope_idstring -
A lowercase alphanumerical string of max 32 characters. Usually an organization id or an environment id, but could really be any suitable suffix for clusters using the CA certificate of this trust. Required unless trust_all is false and trust_allowlist is empty.
-
additional_node_namesstring -
A list of node names trusted in addition to those deducible from trust_allowlist and scope id. Allows trusting nodes that don't have a scoped name at the cost of maintaining the list. Mandatory if scope id is not defined. Wildcards are not allowed.
-
certificatesTrustedCertificaterequired -
The public ca certificate(s) to trust. Only one is required, but it is possible to specify multiple certificates in order to facilitate key rotation.
-
pemstringrequired -
The public ca certificate as string in PEM format.
-
metadataCertificateMetaData -
The certificate MetaData
-
fingerprintstringrequired -
The fingerprint of the certificate
-
valid_tostringrequired -
The expiry date of the certificate in UTC
-
valid_fromstringrequired -
The valid from date of the certificate in UTC
-
also_trusted_bystring -
Other deployments also trusting this certificate
-
keystore_contentsKeystoreContents -
The contents of the Elasticsearch keystore.
-
secretsmap string to KeystoreSecretrequired -
List of secrets
-
<string>KeystoreSecret -
valueobject -
Value of this setting. This can either be a string or a JSON object that is stored as a JSON string in the keystore. NOTE: When the keystore secret is unspecified, it is removed.
-
as_fileboolean -
Stores the keystore secret as a file. The default is false, which stores the keystore secret as string when value is a plain string, or true when value is an object.
-
is_allowlistedboolean -
Read-only field, ignored on write. Only returned when calling the set-deployment-es-resource-keystore endpoint with
validate_only=true. True if this setting/value pair is allowlisted (the allowlist is for informational purposes). -
is_reloadableboolean -
Read-only field, ignored on write. Only returned when calling the set-deployment-es-resource-keystore endpoint with
validate_only=true. True if this setting is reloadable, or if false it requires a cluster restart. -
regionstring -
The region that this cluster belongs to. Only populated in SaaS or federated ECE.
-
lockedboolean -
Whether or not this cluster is locked. Only populated in SaaS.
-
kibanaKibanaResourceInforequired -
List of Kibana resources in your Deployment
-
ref_idstringrequired -
The locally-unique user-specified id of a Resource
-
elasticsearch_cluster_ref_idstringrequired -
The Elasticsearch cluster that this resource depends on.
-
idstringrequired -
The randomly-generated id of a Resource
-
regionstringrequired -
The region where this resource exists
-
infoKibanaClusterInforequired -
The top-level object information for a Kibana instance.
-
cluster_idstringrequired -
The id of the cluster
-
cluster_namestringrequired -
The name of the cluster
-
elasticsearch_clusterTargetElasticsearchClusterrequired -
Information about the specified Elasticsearch cluster.
-
elasticsearch_idstringrequired -
The Elasticsearch cluster Id
-
linksmap string to Hyperlink -
A map of application-specific operations (which map to 'operationId's in the Swagger API) to metadata about that operation
-
<string>Hyperlink -
need_elevated_permissionsboolean -
Whether the operation requires elevated permissions (when the field is present, elevated permissions are required).
-
deployment_idstring -
The id of the deployment to which this Kibana Server belongs to.
-
healthybooleanrequired -
Whether the cluster is healthy or not (one or more of the info subsections will have healthy: false)
-
statusrequired -
Cluster status
-
Values:
initializingstoppingstoppedrebootingrestartingreconfiguringstarted -
plan_infoKibanaClusterPlansInforequired -
Information about the current, pending, or past Kibana instance plans.
-
healthybooleanrequired -
Whether the plan situation is healthy (if unhealthy, means the last plan attempt failed)
-
currentKibanaClusterPlanInfo -
Information about the current, pending, or past Kibana instance plan.
-
plan_attempt_idstring -
A UUID for each plan attempt
-
plan_attempt_namestring -
A human readable name for each plan attempt, only populated when retrieving plan histories
-
healthybooleanrequired -
Either the plan ended successfully, or is not yet completed (and no errors have occurred)
-
attempt_start_timestring -
When this plan attempt (ie to apply the plan to the cluster) started (ISO format in UTC)
-
attempt_end_timestring -
If this plan completed or failed (ie is not pending), when the attempt ended (ISO format in UTC)
-
plan_end_timestring -
If this plan is not current or pending, when the plan was no longer active (ISO format in UTC)
-
planKibanaClusterPlan -
The plan for the Kibana instance.
-
cluster_topologyKibanaClusterTopologyElement -
memory_per_nodeinteger -
The memory capacity in MB for each node of this type built in each zone.
-
node_count_per_zoneinteger -
The number of nodes of this type that are allocated within each zone (i.e. total capacity per zone =
node_count_per_zone*memory_per_nodein MB). -
instance_configuration_idstring -
Controls the allocation of this topology element as well as allowed sizes and node_types. It needs to match the id of an existing instance configuration.
-
instance_configuration_versioninteger -
The version of the Instance Configuration Id. If it is unset, the meaning depends on read vs writes. For deployment reads, it is equivalent to version 0 (or the IC is unversioned); for deployment creates and deployment template use, it is equivalent to 'the latest version'; and for deployment updates, it is equivalent to 'retain the current version'.
-
sizeTopologySize -
Measured by the amount of a resource. The final cluster size is calculated using multipliers from the topology instance configuration.
-
zone_countinteger -
number of zones in which nodes will be placed
-
kibanaKibanaConfiguration -
The Kibana instance settings. When specified at the top level, provides a field-by-field default. When specified at the topology level, provides the override settings.
-
versionstring -
The version of the Kibana cluster (must be one of the ECE supported versions, and won't work unless it matches the Elasticsearch version. Leave blank to auto-detect version.)
-
docker_imagestring -
A docker URI that allows overriding of the default docker image specified for this version
-
system_settingsKibanaSystemSettings -
A subset of Kibana settings. TIP: To define the complete set of Elasticsearch settings, use
KibanaSystemSettingswithuser_settings_override_anduser_settings_. -
elasticsearch_usernamestring -
Optionally override the account within Elasticsearch - defaults to a system account that always exists (if specified, the password must also be specified). Note that this field is never returned from the API, it is write only.
-
elasticsearch_passwordstring -
Optionally override the account within Elasticsearch - defaults to a system account that always exists (if specified, the username must also be specified). Note that this field is never returned from the API, it is write only.
-
user_settings_jsonobject -
An arbitrary JSON object allowing (non-admin) cluster owners to set their parameters (only one of this and 'user_settings_yaml' is allowed), provided the parameters are on the allowlist and not on the denylist. (This field together with 'user_settings_override*' and 'system_settings' defines the total set of Kibana settings)
-
user_settings_yamlstring -
An arbitrary YAML object allowing (non-admin) cluster owners to set their parameters (only one of this and 'user_settings_json' is allowed), provided the parameters are on the allowlist and not on the denylist. (These field together with 'user_settings_override*' and 'system_settings' defines the total set of Kibana settings)
-
user_settings_override_jsonobject -
An arbitrary JSON object allowing ECE admins owners to set clusters' parameters (only one of this and 'user_settings_override_yaml' is allowed), ie in addition to the documented 'system_settings'. (This field together with 'system_settings' and 'user_settings*' defines the total set of Kibana settings)
-
user_settings_override_yamlstring -
An arbitrary YAML object allowing ECE admins owners to set clusters' parameters (only one of this and 'user_settings_override_json' is allowed), ie in addition to the documented 'system_settings'. (This field together with 'system_settings' and 'user_settings*' defines the total set of Kibana settings)
-
kibanaKibanaConfigurationrequired -
The Kibana instance settings. When specified at the top level, provides a field-by-field default. When specified at the topology level, provides the override settings.
-
versionstring -
The version of the Kibana cluster (must be one of the ECE supported versions, and won't work unless it matches the Elasticsearch version. Leave blank to auto-detect version.)
-
docker_imagestring -
A docker URI that allows overriding of the default docker image specified for this version
-
system_settingsKibanaSystemSettings -
A subset of Kibana settings. TIP: To define the complete set of Elasticsearch settings, use
KibanaSystemSettingswithuser_settings_override_anduser_settings_. -
elasticsearch_usernamestring -
Optionally override the account within Elasticsearch - defaults to a system account that always exists (if specified, the password must also be specified). Note that this field is never returned from the API, it is write only.
-
elasticsearch_passwordstring -
Optionally override the account within Elasticsearch - defaults to a system account that always exists (if specified, the username must also be specified). Note that this field is never returned from the API, it is write only.
-
user_settings_jsonobject -
An arbitrary JSON object allowing (non-admin) cluster owners to set their parameters (only one of this and 'user_settings_yaml' is allowed), provided the parameters are on the allowlist and not on the denylist. (This field together with 'user_settings_override*' and 'system_settings' defines the total set of Kibana settings)
-
user_settings_yamlstring -
An arbitrary YAML object allowing (non-admin) cluster owners to set their parameters (only one of this and 'user_settings_json' is allowed), provided the parameters are on the allowlist and not on the denylist. (These field together with 'user_settings_override*' and 'system_settings' defines the total set of Kibana settings)
-
user_settings_override_jsonobject -
An arbitrary JSON object allowing ECE admins owners to set clusters' parameters (only one of this and 'user_settings_override_yaml' is allowed), ie in addition to the documented 'system_settings'. (This field together with 'system_settings' and 'user_settings*' defines the total set of Kibana settings)
-
user_settings_override_yamlstring -
An arbitrary YAML object allowing ECE admins owners to set clusters' parameters (only one of this and 'user_settings_override_json' is allowed), ie in addition to the documented 'system_settings'. (This field together with 'system_settings' and 'user_settings*' defines the total set of Kibana settings)
-
transientTransientKibanaPlanConfiguration -
Defines the configuration parameters that control how the plan is applied. For example, the Elasticsearch cluster topology and Kibana instance settings.
-
strategyPlanStrategy -
The options for performing a plan change. Specify only one property each time. The default is
grow_and_shrink. -
rollingRollingStrategyConfig -
Performs inline, rolling configuration changes that mutate existing containers. TIP: This is the fastest way to update a plan, but can fail for complex plan changes, such as topology changes. Also, this is less safe for configuration changes that leave a cluster in a non running state. NOTE: When you perform a major version upgrade, and 'group_by' is set to 'pass:macros[all]';, rolling is required.
-
group_bystring -
Specifies the grouping attribute to use when rolling several instances. Instances that share the same value for the provided attribute key are rolled together as a unit. Examples that make sense to use are '__all__' (roll all instances as a single unit), 'logical_zone_name' (roll instances by zone), '__name__' (roll one instance at a time, the default if not specified). Note that '__all__' is required when performing a major version upgrade
-
allow_inline_resizeboolean -
Whether we allow changing the capacity of instances (default false). This is currently implemented by stopping, re-creating then starting the affected instance on its associated allocator when performing the changes. NOTES: This requires a round-trip through the allocation infrastructure of the active constructor, as it has to reserve the target capacity without over-committing
-
skip_synced_flushboolean -
Whether to skip attempting to do a synced flush on the filesystem of the container (default: false), which is less safe but may be required if the container is unhealthy
-
shard_init_wait_timeinteger -
The time, in seconds, to wait for shards that show no progress of initializing before rolling the next group (default: 10 minutes)
-
grow_and_shrinkGrowShrinkStrategyConfig -
A strategy that creates instances with the new plan, migrates data from the old instances, then shuts down the old instances.
GrowShrinkStrategyConfigis safer than 'rolling' and ensures single node availability during a plan change, but can be a lot slower on larger clusters. -
rolling_grow_and_shrinkRollingGrowShrinkStrategyConfig -
A strategy that creates new Elasticsearch instances, Kibana instances, and APM Servers with the new plan, then migrates the node data to minimize the amount of spare capacity.
-
autodetectAutodetectStrategyConfig -
A strategy that lets constructor choose the most optimal way to execute the plan.
-
plan_configurationKibanaPlanControlConfiguration -
The configuration settings for the timeout and fallback parameters.
-
timeoutinteger -
The total timeout in seconds after which the plan is cancelled even if it is not complete. Defaults to 4x the max memory capacity per node (in MB)
-
calm_wait_timeinteger -
This timeout determines how long to give a cluster after it responds to API calls before performing actual operations on it. It defaults to 5s
-
move_instancesInstanceMoveRequest -
fromstringrequired -
The instance id that is going to be moved
-
tostring -
An optional list of allocator ids to which the instance should be moved. If not specified then any available allocator can be used (including the current one if it is healthy)
-
instance_downboolean -
Tells the infrastructure that the instance should be considered as permanently down when deciding how to migrate data to new nodes. If left blank then the system will automatically decide (currently: will treat the instances as up)
-
move_allocatorsAllocatorMoveRequest -
fromstringrequired -
The allocator id off which all instances in the cluster should be moved
-
tostring -
An optional list of allocator ids to which the instance(s) should be moved. If not specified then any available allocator can be used (including the current one if it is healthy)
-
allocator_downboolean -
Tells the infrastructure that all instances on the allocator should be considered as permanently down when deciding how to migrate data to new nodes. If left blank then the system will auto-decide (currently: will treat the allocator as up)
-
reallocate_instancesboolean -
If true (default: false) does not allow re-using any existing instances currently in the cluster, ie even unchanged instances will be re-created
-
preferred_allocatorsstring -
List of allocators on which instances are placed if possible (if not possible/not specified then any available allocator with space is used)
-
Map containing allocators tags in form of key value pairs, increasing the likelihood during move requests for allocators with matching tags, to be selected as target allocators
-
extended_maintenanceboolean -
If true (default false), does not clear the maintenance flag (which prevents its API from being accessed except by the constructor) on new instances added until after a snapshot has been restored, otherwise, the maintenance flag is cleared once the new instances successfully join the new cluster
-
override_failsafeboolean -
If false (the default), the plan fails if it determines that the request can result in unsafe operations. Setting this flag overrides some of these check restraints.
-
plan_attempt_logClusterPlanStepInforequired -
sourceChangeSourceInfo -
A container for information about the source of a change.
-
facilitatorstringrequired -
The service where the change originated from
-
actionstringrequired -
The type of plan change that was initiated
-
datestringrequired -
The time the change was initiated
-
user_idstring -
The user that requested the change
-
admin_idstring -
The admin user that requested the change
-
remote_addressesstring -
The host addresses of the user that originated the change
-
warningsClusterPlanWarningrequired -
errorClusterPlanAttemptError -
Information about an error during a plan attempt.
-
timestampstringrequired -
Timestamp marking on info log of step
-
messagestringrequired -
Human readable error message
-
detailsmap string to stringrequired -
A map with details regarding the error. Both the keys and values are always strings, representing the name of the detail and its value, respectively.
-
failure_typestring -
The failure type
-
pendingKibanaClusterPlanInfo -
Information about the current, pending, or past Kibana instance plan.
-
historyKibanaClusterPlanInforequired -
metadataClusterMetadataInforequired -
Information about the public and internal state, and the configuration settings of an Elasticsearch cluster.
-
topologyClusterTopologyInforequired -
The topology for Elasticsearch clusters, multiple Kibana instances, or multiple APM Servers. The
ClusterTopologyInfoalso includes the instances and containers, and where they are located. -
external_linksExternalHyperlink · uniquerequired -
External resources related to the cluster
-
linksmap string to Hyperlink -
A map of application-specific operations (which map to 'operationId's in the Swagger API) to metadata about that operation
-
<string>Hyperlink -
need_elevated_permissionsboolean -
Whether the operation requires elevated permissions (when the field is present, elevated permissions are required).
-
settingsKibanaClusterSettings -
The settings for multiple Kibana instances.
-
metadataClusterMetadataSettings -
The top-level configuration settings for the Elasticsearch cluster.
-
regionstring -
The region that this cluster belongs to. Only populated in SaaS or federated ECE.
-
apmApmResourceInforequired -
List of Apm resources in your Deployment
-
ref_idstringrequired -
The locally-unique user-specified id of a Resource
-
elasticsearch_cluster_ref_idstringrequired -
The Elasticsearch cluster that this resource depends on.
-
idstringrequired -
The randomly-generated id of a Resource
-
regionstringrequired -
The region where this resource exists
-
infoApmInforequired -
The overview information for the APM Server.
-
idstringrequired -
The id of the APM
-
namestringrequired -
The name of the APM
-
elasticsearch_clusterTargetElasticsearchClusterrequired -
Information about the specified Elasticsearch cluster.
-
elasticsearch_idstringrequired -
The Elasticsearch cluster Id
-
linksmap string to Hyperlink -
A map of application-specific operations (which map to 'operationId's in the Swagger API) to metadata about that operation
-
<string>Hyperlink -
need_elevated_permissionsboolean -
Whether the operation requires elevated permissions (when the field is present, elevated permissions are required).
-
deployment_idstring -
The id of the deployment that this APM Server belongs to.
-
healthybooleanrequired -
Whether the APM is healthy or not (one or more of the info subsections will have healthy: false)
-
statusrequired -
APM status
-
Values:
initializingstoppingstoppedrebootingrestartingreconfiguringstarted -
plan_infoApmPlansInforequired -
Information about current, pending, and past APM Server plans.
-
healthybooleanrequired -
Whether the plan situation is healthy (if unhealthy, means the last plan attempt failed)
-
currentApmPlanInfo -
Information about the APM Server plan.
-
plan_attempt_idstring -
A UUID for each plan attempt
-
plan_attempt_namestring -
A human readable name for each plan attempt, only populated when retrieving plan histories
-
healthybooleanrequired -
Either the plan ended successfully, or is not yet completed (and no errors have occurred)
-
attempt_start_timestring -
When this plan attempt (ie to apply the plan to the APM) started (ISO format in UTC)
-
attempt_end_timestring -
If this plan completed or failed (ie is not pending), when the attempt ended (ISO format in UTC)
-
plan_end_timestring -
If this plan is not current or pending, when the plan was no longer active (ISO format in UTC)
-
planApmPlan -
The plan for the APM Server.
-
cluster_topologyApmTopologyElement -
instance_configuration_idstring -
Controls the allocation of this topology element as well as allowed sizes and node_types. It needs to match the id of an existing instance configuration.
-
instance_configuration_versioninteger -
The version of the Instance Configuration Id. If it is unset, the meaning depends on read vs writes. For deployment reads, it is equivalent to version 0 (or the IC is unversioned); for deployment creates and deployment template use, it is equivalent to 'the latest version'; and for deployment updates, it is equivalent to 'retain the current version'.
-
sizeTopologySize -
Measured by the amount of a resource. The final cluster size is calculated using multipliers from the topology instance configuration.
-
zone_countinteger -
number of zones in which nodes will be placed
-
apmApmConfiguration -
The configuration options for the APM Server.
-
versionstring -
The version of the Apm cluster (must be one of the ECE supported versions, and won't work unless it matches the APM version. Leave blank to auto-detect version.)
-
docker_imagestring -
A docker URI that allows overriding of the default docker image specified for this version
-
system_settingsApmSystemSettings -
A structure that defines a curated subset of the APM Server settings. TIP: To define the complete set of APM Server setting, use
ApmSystemSettingswithuser_settings_override_anduser_settings_. -
elasticsearch_usernamestring -
Optionally override the account within APM - defaults to a system account that always exists (if specified, the password must also be specified). Note that this field is never returned from the API, it is write only.
-
elasticsearch_passwordstring -
Optionally override the account within APM - defaults to a system account that always exists (if specified, the username must also be specified). Note that this field is never returned from the API, it is write only.
-
secret_tokenstring -
Optionally override the secret token within APM - defaults to the previously existing secretToken
-
debug_enabledboolean -
Optionally enable debug mode for APM servers - defaults false
-
user_settings_jsonobject -
An arbitrary JSON object allowing (non-admin) cluster owners to set their parameters (only one of this and 'user_settings_yaml' is allowed), provided the parameters are on the allowlist and not on the denylist. (This field together with 'user_settings_override*' and 'system_settings' defines the total set of Apm settings)
-
user_settings_yamlstring -
An arbitrary YAML object allowing (non-admin) cluster owners to set their parameters (only one of this and 'user_settings_json' is allowed), provided the parameters are on the allowlist and not on the denylist. (These field together with 'user_settings_override*' and 'system_settings' defines the total set of Apm settings)
-
user_settings_override_jsonobject -
An arbitrary JSON object allowing ECE admins owners to set clusters' parameters (only one of this and 'user_settings_override_yaml' is allowed), ie in addition to the documented 'system_settings'. (This field together with 'system_settings' and 'user_settings*' defines the total set of Apm settings)
-
user_settings_override_yamlstring -
An arbitrary YAML object allowing ECE admins owners to set clusters' parameters (only one of this and 'user_settings_override_json' is allowed), ie in addition to the documented 'system_settings'. (This field together with 'system_settings' and 'user_settings*' defines the total set of Apm settings)
-
apmApmConfigurationrequired -
The configuration options for the APM Server.
-
transientTransientApmPlanConfiguration -
Defines the configuration parameters that control how the plan is applied. For example, the Elasticsearch cluster topology and APM Server settings.
-
strategyPlanStrategy -
The options for performing a plan change. Specify only one property each time. The default is
grow_and_shrink. -
rollingRollingStrategyConfig -
Performs inline, rolling configuration changes that mutate existing containers. TIP: This is the fastest way to update a plan, but can fail for complex plan changes, such as topology changes. Also, this is less safe for configuration changes that leave a cluster in a non running state. NOTE: When you perform a major version upgrade, and 'group_by' is set to 'pass:macros[all]';, rolling is required.
-
group_bystring -
Specifies the grouping attribute to use when rolling several instances. Instances that share the same value for the provided attribute key are rolled together as a unit. Examples that make sense to use are '__all__' (roll all instances as a single unit), 'logical_zone_name' (roll instances by zone), '__name__' (roll one instance at a time, the default if not specified). Note that '__all__' is required when performing a major version upgrade
-
allow_inline_resizeboolean -
Whether we allow changing the capacity of instances (default false). This is currently implemented by stopping, re-creating then starting the affected instance on its associated allocator when performing the changes. NOTES: This requires a round-trip through the allocation infrastructure of the active constructor, as it has to reserve the target capacity without over-committing
-
skip_synced_flushboolean -
Whether to skip attempting to do a synced flush on the filesystem of the container (default: false), which is less safe but may be required if the container is unhealthy
-
shard_init_wait_timeinteger -
The time, in seconds, to wait for shards that show no progress of initializing before rolling the next group (default: 10 minutes)
-
grow_and_shrinkGrowShrinkStrategyConfig -
A strategy that creates instances with the new plan, migrates data from the old instances, then shuts down the old instances.
GrowShrinkStrategyConfigis safer than 'rolling' and ensures single node availability during a plan change, but can be a lot slower on larger clusters. -
rolling_grow_and_shrinkRollingGrowShrinkStrategyConfig -
A strategy that creates new Elasticsearch instances, Kibana instances, and APM Servers with the new plan, then migrates the node data to minimize the amount of spare capacity.
-
autodetectAutodetectStrategyConfig -
A strategy that lets constructor choose the most optimal way to execute the plan.
-
plan_configurationApmPlanControlConfiguration -
The plan control configuration options for the APM Server.
-
timeoutinteger -
The total timeout in seconds after which the plan is cancelled even if it is not complete. Defaults to 4x the max memory capacity per node (in MB)
-
calm_wait_timeinteger -
This timeout determines how long to give a cluster after it responds to API calls before performing actual operations on it. It defaults to 5s
-
move_instancesInstanceMoveRequest -
fromstringrequired -
The instance id that is going to be moved
-
tostring -
An optional list of allocator ids to which the instance should be moved. If not specified then any available allocator can be used (including the current one if it is healthy)
-
instance_downboolean -
Tells the infrastructure that the instance should be considered as permanently down when deciding how to migrate data to new nodes. If left blank then the system will automatically decide (currently: will treat the instances as up)
-
move_allocatorsAllocatorMoveRequest -
fromstringrequired -
The allocator id off which all instances in the cluster should be moved
-
tostring -
An optional list of allocator ids to which the instance(s) should be moved. If not specified then any available allocator can be used (including the current one if it is healthy)
-
allocator_downboolean -
Tells the infrastructure that all instances on the allocator should be considered as permanently down when deciding how to migrate data to new nodes. If left blank then the system will auto-decide (currently: will treat the allocator as up)
-
reallocate_instancesboolean -
If true (default: false) does not allow re-using any existing instances currently in the cluster, ie even unchanged instances will be re-created
-
preferred_allocatorsstring -
List of allocators on which instances are placed if possible (if not possible/not specified then any available allocator with space is used)
-
Map containing allocators tags in form of key value pairs, increasing the likelihood during move requests for allocators with matching tags, to be selected as target allocators
-
extended_maintenanceboolean -
If true (default false), does not clear the maintenance flag (which prevents its API from being accessed except by the constructor) on new instances added until after a snapshot has been restored, otherwise, the maintenance flag is cleared once the new instances successfully join the new cluster
-
override_failsafeboolean -
If false (the default), the plan fails if it determines that the request can result in unsafe operations. Setting this flag overrides some of these check restraints.
-
plan_attempt_logClusterPlanStepInforequired -
sourceChangeSourceInfo -
A container for information about the source of a change.
-
facilitatorstringrequired -
The service where the change originated from
-
actionstringrequired -
The type of plan change that was initiated
-
datestringrequired -
The time the change was initiated
-
user_idstring -
The user that requested the change
-
admin_idstring -
The admin user that requested the change
-
remote_addressesstring -
The host addresses of the user that originated the change
-
warningsClusterPlanWarningrequired -
errorClusterPlanAttemptError -
Information about an error during a plan attempt.
-
timestampstringrequired -
Timestamp marking on info log of step
-
messagestringrequired -
Human readable error message
-
detailsmap string to stringrequired -
A map with details regarding the error. Both the keys and values are always strings, representing the name of the detail and its value, respectively.
-
failure_typestring -
The failure type
-
pendingApmPlanInfo -
Information about the APM Server plan.
-
historyApmPlanInforequired -
metadataClusterMetadataInfo -
Information about the public and internal state, and the configuration settings of an Elasticsearch cluster.
-
topologyClusterTopologyInforequired -
The topology for Elasticsearch clusters, multiple Kibana instances, or multiple APM Servers. The
ClusterTopologyInfoalso includes the instances and containers, and where they are located. -
external_linksExternalHyperlink · uniquerequired -
External resources related to the APM
-
linksmap string to Hyperlink -
A map of application-specific operations (which map to 'operationId's in the Swagger API) to metadata about that operation
-
<string>Hyperlink -
need_elevated_permissionsboolean -
Whether the operation requires elevated permissions (when the field is present, elevated permissions are required).
-
settingsApmSettings -
The settings for the APM Server.
-
metadataClusterMetadataSettings -
The top-level configuration settings for the Elasticsearch cluster.
-
regionstring -
The region that this APM belongs to. Only populated in SaaS or federated ECE.
-
appsearchAppSearchResourceInforequired -
List of App Search resources in your Deployment
-
ref_idstringrequired -
The locally-unique user-specified id of a Resource
-
elasticsearch_cluster_ref_idstringrequired -
The Elasticsearch cluster that this resource depends on.
-
idstringrequired -
The randomly-generated id of a Resource
-
regionstringrequired -
The region where this resource exists
-
infoAppSearchInforequired -
The overview information for the App Search Server.
-
idstringrequired -
The id of the App Search
-
namestringrequired -
The name of the App Search
-
elasticsearch_clusterTargetElasticsearchClusterrequired -
Information about the specified Elasticsearch cluster.
-
elasticsearch_idstringrequired -
The Elasticsearch cluster Id
-
linksmap string to Hyperlink -
A map of application-specific operations (which map to 'operationId's in the Swagger API) to metadata about that operation
-
<string>Hyperlink -
need_elevated_permissionsboolean -
Whether the operation requires elevated permissions (when the field is present, elevated permissions are required).
-
deployment_idstring -
The id of the deployment that this App Search belongs to.
-
healthybooleanrequired -
Whether the App Search is healthy or not (one or more of the info subsections will have healthy: false)
-
statusrequired -
App Search status
-
Values:
initializingstoppingstoppedrebootingrestartingreconfiguringstarted -
plan_infoAppSearchPlansInforequired -
Information about current, pending, and past App Search Server plans.
-
healthybooleanrequired -
Whether the plan situation is healthy (if unhealthy, means the last plan attempt failed)
-
currentAppSearchPlanInfo -
Information about the App Search Server plan.
-
plan_attempt_idstring -
A UUID for each plan attempt
-
plan_attempt_namestring -
A human readable name for each plan attempt, only populated when retrieving plan histories
-
healthybooleanrequired -
Either the plan ended successfully, or is not yet completed (and no errors have occurred)
-
attempt_start_timestring -
When this plan attempt (ie to apply the plan to the App Search) started (ISO format in UTC)
-
attempt_end_timestring -
If this plan completed or failed (ie is not pending), when the attempt ended (ISO format in UTC)
-
plan_end_timestring -
If this plan is not current or pending, when the plan was no longer active (ISO format in UTC)
-
planAppSearchPlan -
The plan for the App Search cluster.
-
cluster_topologyAppSearchTopologyElement -
node_typeAppSearchNodeTypes -
Node types to enable for an AppSearch instance
-
instance_configuration_idstring -
Controls the allocation of this topology element as well as allowed sizes and node_types. It needs to match the id of an existing instance configuration.
-
instance_configuration_versioninteger -
The version of the Instance Configuration Id. If it is unset, the meaning depends on read vs writes. For deployment reads, it is equivalent to version 0 (or the IC is unversioned); for deployment creates and deployment template use, it is equivalent to 'the latest version'; and for deployment updates, it is equivalent to 'retain the current version'.
-
sizeTopologySize -
Measured by the amount of a resource. The final cluster size is calculated using multipliers from the topology instance configuration.
-
zone_countinteger -
number of zones in which nodes will be placed
-
appsearchAppSearchConfiguration -
versionstring -
The version of the AppSearch cluster (must be one of the ECE supported versions, and won't work unless it matches the Elasticsearch version. Leave blank to auto-detect version.)
-
docker_imagestring -
A docker URI that allows overriding of the default docker image specified for this version
-
system_settingsAppSearchSystemSettings -
This structure defines a curated subset of the AppSearch settings. (This field together with 'user_settings_override*' and 'user_settings*' defines the total set of AppSearch settings)
-
elasticsearch_urlstring -
Optionally override the URL to which to send data (for advanced users only, if unspecified the system selects an internal URL)
-
elasticsearch_usernamestring -
Optionally override the account within App Search - defaults to a system account that always exists (if specified, the password must also be specified). Note that this field is never returned from the API, it is write only.
-
elasticsearch_passwordstring -
Optionally override the account within App Search - defaults to a system account that always exists (if specified, the username must also be specified). Note that this field is never returned from the API, it is write only.
-
secret_session_keystring -
Optionally override the secret session key within App Search - defaults to the previously existing secretSession. Note that this field is never returned from the API, it is write only.
-
user_settings_jsonobject -
An arbitrary JSON object allowing (non-admin) cluster owners to set their parameters (only one of this and 'user_settings_yaml' is allowed), provided the parameters are on the allowlist and not on the denylist. (This field together with 'user_settings_override*' and 'system_settings' defines the total set of AppSearch settings)
-
user_settings_yamlstring -
An arbitrary YAML object allowing (non-admin) cluster owners to set their parameters (only one of this and 'user_settings_json' is allowed), provided the parameters are on the allowlist and not on the denylist. (These field together with 'user_settings_override*' and 'system_settings' defines the total set of AppSearch settings)
-
user_settings_override_jsonobject -
An arbitrary JSON object allowing ECE admins owners to set clusters' parameters (only one of this and 'user_settings_override_yaml' is allowed), ie in addition to the documented 'system_settings'. (This field together with 'system_settings' and 'user_settings*' defines the total set of AppSearch settings)
-
user_settings_override_yamlstring -
An arbitrary YAML object allowing ECE admins owners to set clusters' parameters (only one of this and 'user_settings_override_json' is allowed), ie in addition to the documented 'system_settings'. (This field together with 'system_settings' and 'user_settings*' defines the total set of AppSearch settings)
-
appsearchAppSearchConfigurationrequired -
transientTransientAppSearchPlanConfiguration -
Defines configuration parameters that control how the plan (ie consisting of the cluster topology and AppSearch settings) is applied
-
strategyPlanStrategy -
The options for performing a plan change. Specify only one property each time. The default is
grow_and_shrink. -
rollingRollingStrategyConfig -
Performs inline, rolling configuration changes that mutate existing containers. TIP: This is the fastest way to update a plan, but can fail for complex plan changes, such as topology changes. Also, this is less safe for configuration changes that leave a cluster in a non running state. NOTE: When you perform a major version upgrade, and 'group_by' is set to 'pass:macros[all]';, rolling is required.
-
group_bystring -
Specifies the grouping attribute to use when rolling several instances. Instances that share the same value for the provided attribute key are rolled together as a unit. Examples that make sense to use are '__all__' (roll all instances as a single unit), 'logical_zone_name' (roll instances by zone), '__name__' (roll one instance at a time, the default if not specified). Note that '__all__' is required when performing a major version upgrade
-
allow_inline_resizeboolean -
Whether we allow changing the capacity of instances (default false). This is currently implemented by stopping, re-creating then starting the affected instance on its associated allocator when performing the changes. NOTES: This requires a round-trip through the allocation infrastructure of the active constructor, as it has to reserve the target capacity without over-committing
-
skip_synced_flushboolean -
Whether to skip attempting to do a synced flush on the filesystem of the container (default: false), which is less safe but may be required if the container is unhealthy
-
shard_init_wait_timeinteger -
The time, in seconds, to wait for shards that show no progress of initializing before rolling the next group (default: 10 minutes)
-
grow_and_shrinkGrowShrinkStrategyConfig -
A strategy that creates instances with the new plan, migrates data from the old instances, then shuts down the old instances.
GrowShrinkStrategyConfigis safer than 'rolling' and ensures single node availability during a plan change, but can be a lot slower on larger clusters. -
rolling_grow_and_shrinkRollingGrowShrinkStrategyConfig -
A strategy that creates new Elasticsearch instances, Kibana instances, and APM Servers with the new plan, then migrates the node data to minimize the amount of spare capacity.
-
autodetectAutodetectStrategyConfig -
A strategy that lets constructor choose the most optimal way to execute the plan.
-
plan_configurationAppSearchPlanControlConfiguration -
timeoutinteger -
The total timeout in seconds after which the plan is cancelled even if it is not complete. Defaults to 4x the max memory capacity per node (in MB)
-
calm_wait_timeinteger -
This timeout determines how long to give a cluster after it responds to API calls before performing actual operations on it. It defaults to 5s
-
move_instancesInstanceMoveRequest -
fromstringrequired -
The instance id that is going to be moved
-
tostring -
An optional list of allocator ids to which the instance should be moved. If not specified then any available allocator can be used (including the current one if it is healthy)
-
instance_downboolean -
Tells the infrastructure that the instance should be considered as permanently down when deciding how to migrate data to new nodes. If left blank then the system will automatically decide (currently: will treat the instances as up)
-
move_allocatorsAllocatorMoveRequest -
fromstringrequired -
The allocator id off which all instances in the cluster should be moved
-
tostring -
An optional list of allocator ids to which the instance(s) should be moved. If not specified then any available allocator can be used (including the current one if it is healthy)
-
allocator_downboolean -
Tells the infrastructure that all instances on the allocator should be considered as permanently down when deciding how to migrate data to new nodes. If left blank then the system will auto-decide (currently: will treat the allocator as up)
-
reallocate_instancesboolean -
If true (default: false) does not allow re-using any existing instances currently in the cluster, ie even unchanged instances will be re-created
-
preferred_allocatorsstring -
List of allocators on which instances are placed if possible (if not possible/not specified then any available allocator with space is used)
-
Map containing allocators tags in form of key value pairs, increasing the likelihood during move requests for allocators with matching tags, to be selected as target allocators
-
extended_maintenanceboolean -
If true (default false), does not clear the maintenance flag (which prevents its API from being accessed except by the constructor) on new instances added until after a snapshot has been restored, otherwise, the maintenance flag is cleared once the new instances successfully join the new cluster
-
override_failsafeboolean -
If false (the default), the plan fails if it determines that the request can result in unsafe operations. Setting this flag overrides some of these check restraints.
-
plan_attempt_logClusterPlanStepInforequired -
sourceChangeSourceInfo -
A container for information about the source of a change.
-
facilitatorstringrequired -
The service where the change originated from
-
actionstringrequired -
The type of plan change that was initiated
-
datestringrequired -
The time the change was initiated
-
user_idstring -
The user that requested the change
-
admin_idstring -
The admin user that requested the change
-
remote_addressesstring -
The host addresses of the user that originated the change
-
warningsClusterPlanWarningrequired -
errorClusterPlanAttemptError -
Information about an error during a plan attempt.
-
timestampstringrequired -
Timestamp marking on info log of step
-
messagestringrequired -
Human readable error message
-
detailsmap string to stringrequired -
A map with details regarding the error. Both the keys and values are always strings, representing the name of the detail and its value, respectively.
-
failure_typestring -
The failure type
-
pendingAppSearchPlanInfo -
Information about the App Search Server plan.
-
historyAppSearchPlanInforequired -
metadataClusterMetadataInfo -
Information about the public and internal state, and the configuration settings of an Elasticsearch cluster.
-
topologyClusterTopologyInforequired -
The topology for Elasticsearch clusters, multiple Kibana instances, or multiple APM Servers. The
ClusterTopologyInfoalso includes the instances and containers, and where they are located. -
external_linksExternalHyperlink · uniquerequired -
External resources related to the App Search
-
linksmap string to Hyperlink -
A map of application-specific operations (which map to 'operationId's in the Swagger API) to metadata about that operation
-
<string>Hyperlink -
need_elevated_permissionsboolean -
Whether the operation requires elevated permissions (when the field is present, elevated permissions are required).
-
settingsAppSearchSettings -
The settings for the App Search.
-
metadataClusterMetadataSettings -
The top-level configuration settings for the Elasticsearch cluster.
-
regionstring -
The region that this App Search belongs to. Only populated in SaaS or federated ECE.
-
enterprise_searchEnterpriseSearchResourceInforequired -
List of Enterprise Search resources in your Deployment
-
ref_idstringrequired -
The locally-unique user-specified id of a Resource
-
elasticsearch_cluster_ref_idstringrequired -
The Elasticsearch cluster that this resource depends on.
-
idstringrequired -
The randomly-generated id of a Resource
-
regionstringrequired -
The region where this resource exists
-
infoEnterpriseSearchInforequired -
The overview information for the Enterprise Search Server.
-
idstringrequired -
The id of the Enterprise Search
-
namestringrequired -
The name of the Enterprise Search
-
elasticsearch_clusterTargetElasticsearchClusterrequired -
Information about the specified Elasticsearch cluster.
-
elasticsearch_idstringrequired -
The Elasticsearch cluster Id
-
linksmap string to Hyperlink -
A map of application-specific operations (which map to 'operationId's in the Swagger API) to metadata about that operation
-
<string>Hyperlink -
need_elevated_permissionsboolean -
Whether the operation requires elevated permissions (when the field is present, elevated permissions are required).
-
deployment_idstring -
The id of the deployment that this Enterprise Search belongs to.
-
healthybooleanrequired -
Whether the Enterprise Search is healthy or not (one or more of the info subsections will have healthy: false)
-
statusrequired -
Enterprise Search status
-
Values:
initializingstoppingstoppedrebootingrestartingreconfiguringstarted -
plan_infoEnterpriseSearchPlansInforequired -
Information about current, pending, and past Enterprise Search Server plans.
-
healthybooleanrequired -
Whether the plan situation is healthy (if unhealthy, means the last plan attempt failed)
-
currentEnterpriseSearchPlanInfo -
Information about the Enterprise Search Server plan.
-
plan_attempt_idstring -
A UUID for each plan attempt
-
plan_attempt_namestring -
[...]
